# Generated by Django 2.2.3 on 2020-04-02 22:34

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('users', '0008_auto_20200220_1702'),
    ]

    operations = [
        migrations.CreateModel(
            name='Menu',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=50, unique=True, verbose_name='菜单')),
                ('grade', models.IntegerField(default=1, verbose_name='菜单级别')),
                ('operate_user', models.CharField(default='admin', max_length=32, verbose_name='操作人')),
                ('operate_date', models.DateTimeField(auto_now_add=True, verbose_name='操作时间')),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='subClasses', to='users.Menu', verbose_name='父类目别')),
            ],
            options={
                'verbose_name_plural': '菜单表',
                'db_table': 'menu',
            },
        ),
        migrations.CreateModel(
            name='Permission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=32, unique=True)),
                ('url', models.CharField(max_length=128, unique=True)),
                ('codes', models.CharField(default='list', max_length=32, verbose_name='权限代码')),
                ('menu', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='users.Menu')),
            ],
            options={
                'verbose_name_plural': '权限表',
                'db_table': 'permission',
            },
        ),
        migrations.CreateModel(
            name='Role',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=32, unique=True)),
                ('permissions', models.ManyToManyField(blank=True, to='users.Permission', verbose_name='角色的权限')),
            ],
            options={
                'verbose_name_plural': '角色表',
                'db_table': 'role',
            },
        ),
        migrations.AddField(
            model_name='user',
            name='roles',
            field=models.ManyToManyField(to='users.Role'),
        ),
    ]
